(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/material/icon'), require('@angular/material/core'), require('@angular/material/button')) :
    typeof define === 'function' && define.amd ? define('gixngbuttons', ['exports', '@angular/core', '@angular/material/icon', '@angular/material/core', '@angular/material/button'], factory) :
    (factory((global.gixngbuttons = {}),global.ng.core,global.ng.material.icon,global.ng.material.core,global.ng.material.button));
}(this, (function (exports,i0,icon,core,button) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GIXNGButtonsService = /** @class */ (function () {
        function GIXNGButtonsService() {
        }
        /**
         * @param {?} icon
         * @return {?}
         */
        GIXNGButtonsService.prototype.getEasyNaming = /**
         * @param {?} icon
         * @return {?}
         */
            function (icon$$1) {
                switch (icon$$1) {
                    case "profile":
                        return "people";

                    case "profil": return "people";
                    case "login": return "lock";
                    case "connect": return "lock";
                    case "log-in": return "lock";
                    case "logout": return "lock_open";
                    case "disconnect": return "lock_open";
                    case "log-out": return "lock_open";
                    default:
                        return icon$$1;
                        break;
                }
            };
        GIXNGButtonsService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        GIXNGButtonsService.ctorParameters = function () { return []; };
        /** @nocollapse */ GIXNGButtonsService.ngInjectableDef = i0.defineInjectable({ factory: function GIXNGButtonsService_Factory() { return new GIXNGButtonsService(); }, token: GIXNGButtonsService, providedIn: "root" });
        return GIXNGButtonsService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GixButtonCornectoComponent = /** @class */ (function () {
        function GixButtonCornectoComponent(gIXNGButtonsService) {
            this.gIXNGButtonsService = gIXNGButtonsService;
            //does some mapping of common name
            if (this.icon) {
                this.iconValue = this.gIXNGButtonsService.getEasyNaming(this.icon);
                console.log("Button icon:" + this.icon + '/' + this.iconValue);
            }
            //default value for buttons/icon
            if (!this.txt)
                this.txt = "create";
            if (!this.icon)
                this.icon = "add";
            if (!this.color)
                this.color = "primary";
        }
        /**
         * @return {?}
         */
        GixButtonCornectoComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        GixButtonCornectoComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'gix-button-cornecto',
                        template: "<!--@STCGoal Goal: Make this button shaped like the Corner rectangle with an Icon + Create a Component for that button type:-->\n\n\n<button mat-raised-button [color]=\"color\"  class=\"gix-button-shadow gix-cornecto-button\">  \n    <mat-icon>{{iconValue}}</mat-icon>  \n     <span class=\"gix-button-cornecto-label\">{{txt}}</span>\n</button>\n\n",
                        styles: [".gix-button-shadow{box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12);-webkit-box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12)}.gix-button-cornecto-label{justify-content:flex-start;text-overflow:ellipsis;white-space:nowrap;overflow:hidden}.gix-cornecto-button{font-family:Roboto,sans-serif;-moz-osx-font-smoothing:grayscale;-webkit-font-smoothing:antialiased;font-size:.875rem;line-height:2.25rem;font-weight:500;letter-spacing:.0892857143em;text-decoration:none;text-transform:uppercase;border-radius:12px;padding:0 20px;width:auto;max-width:100%;margin-right:24px}"]
                    }] }
        ];
        /** @nocollapse */
        GixButtonCornectoComponent.ctorParameters = function () {
            return [
                { type: GIXNGButtonsService }
            ];
        };
        GixButtonCornectoComponent.propDecorators = {
            txt: [{ type: i0.Input }],
            icon: [{ type: i0.Input }],
            color: [{ type: i0.Input }]
        };
        return GixButtonCornectoComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GixButtonTwolcornComponent = /** @class */ (function () {
        function GixButtonTwolcornComponent(gIXNGButtonsService) {
            this.gIXNGButtonsService = gIXNGButtonsService;
            //does some mapping of common name
            if (this.icon) {
                this.iconValue = this.gIXNGButtonsService.getEasyNaming(this.icon);
            }
            //default value for buttons/icon
            if (!this.txt)
                this.txt = "";
            if (!this.icon)
                this.icon = "add";
            if (!this.color)
                this.color = "primary";
        }
        /**
         * @return {?}
         */
        GixButtonTwolcornComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var textFactor = 17;
                if (this.txt) {
                    /** @type {?} */
                    var newLenght = this.txt.length * textFactor;
                    this.gixTwoCornButton.nativeElement.style.width = newLenght + "px";
                }
            };
        GixButtonTwolcornComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'gix-button-twolcorn',
                        template: "\n    <!--@feature gix-button-twolcorner\n      <h5> A Nice rouded only at two corner and sharp at the other FAB</h5>\n    <h6>CSS CLASS: gix-button-twolcorner</h6>-->\n    \n    <button \n      mat-fab [color]=\"color\" class=\"gix-button-twolcorn\" #gixTwoCornButton>\n        <mat-icon>{{iconValue}}</mat-icon>\n        <span class=\"tstlabelclass\" #gitTwoCornButtonLabel>{{txt}}</span>\n      </button>",
                        styles: [".gix-button-twolcorn{border-radius:50% 0}.gix-button-shadow{box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12);-webkit-box-shadow:0 3px 5px -1px rgba(0,0,0,.2),0 6px 10px 0 rgba(0,0,0,.14),0 1px 18px 0 rgba(0,0,0,.12)}"]
                    }] }
        ];
        /** @nocollapse */
        GixButtonTwolcornComponent.ctorParameters = function () {
            return [
                { type: GIXNGButtonsService }
            ];
        };
        GixButtonTwolcornComponent.propDecorators = {
            gixTwoCornButton: [{ type: i0.ViewChild, args: ["gixTwoCornButton", { read: i0.ElementRef },] }],
            gitTwoCornButtonLabel: [{ type: i0.ViewChild, args: ["gitTwoCornButtonLabel", { read: i0.ElementRef },] }],
            txt: [{ type: i0.Input }],
            icon: [{ type: i0.Input }],
            color: [{ type: i0.Input }]
        };
        return GixButtonTwolcornComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var GIXNGButtonsModule = /** @class */ (function () {
        function GIXNGButtonsModule() {
        }
        GIXNGButtonsModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [GixButtonCornectoComponent, GixButtonTwolcornComponent],
                        imports: [
                            icon.MatIconModule,
                            core.MatRippleModule,
                            button.MatButtonModule
                        ],
                        exports: [GixButtonCornectoComponent, GixButtonTwolcornComponent, button.MatButtonModule]
                    },] }
        ];
        return GIXNGButtonsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.GIXNGButtonsService = GIXNGButtonsService;
    exports.GixButtonCornectoComponent = GixButtonCornectoComponent;
    exports.GixButtonTwolcornComponent = GixButtonTwolcornComponent;
    exports.GIXNGButtonsModule = GIXNGButtonsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=gixngbuttons.umd.js.map